import java.io.*;
import java.net.*;
import java.util.*;

public class AMWInfogetter implements Runnable{
	private URL url;
	private SortedMap<String, Book> map;
	private StringBuffer sb;

	public AMWInfogetter(URL url, SortedMap<String, Book> map, StringBuffer sb){
		this.url = url;
		this.map = map;
		this.sb = sb;
	}

	public void run(){
		try{
			URLConnection connection =url.openConnection();
			connection.connect();
			BufferedReader reader =
				new BufferedReader(
						new InputStreamReader(
								connection.getInputStream(),
								"utf-8"));
			String line;
			String title = null;
			String label = null;
			String date = null;
			String[] labelArray = {"魔法のiらんどの単行本",
									"魔法のiらんど文庫",
									"メディアワークス文庫",
									"シルフコミックス",
									"電撃コミックス",
									"つばさ文庫",
									"電撃ジャパンコミックス",
									"電撃文庫",
									"B-PRINCE文庫"};
			boolean flag = false;
			boolean flag2 = false;
			while((line = reader.readLine()) != null){
				//開始条件
				if(line.indexOf("calendarT") != -1){
					flag = true;
				}
				//終了条件
				if(((flag == true) && line.indexOf("</table>") != -1)){
					break;
				}
				if(flag == true){
					int offset;
					int offset2;
					int offset3;
					//日付取り出し
					if((offset=line.indexOf("th1")) != -1){
						offset2 = line.indexOf(">",offset);
						offset3 = line.lastIndexOf("<");
						date = line.substring(offset2+1, offset3);
					}
					//レーベル取り出し
					else if((offset=line.indexOf("th2")) != -1){
						offset2 = line.indexOf(">",offset);
						offset3 = line.lastIndexOf("<");
						label = line.substring(offset2+1, offset3);
						for(int i = 0; i < labelArray.length; i++){

							if(label.equals(labelArray[i])){
								flag2 = true;
								break;
							}
						}
					}
					if((flag2 == true) && (line.indexOf("</ul>") != -1)){
						flag2 = false;
					}
					//タイトル取り出し
					if((flag2 == true) && ((offset = line.indexOf("li")) != -1)){
						offset2 = line.indexOf(">",offset);
						offset3 = line.lastIndexOf("<");
						title = line.substring(offset2+1, offset3);
						title = title.replaceAll("&#39;", "'");
						this.map.put(title, new Book(title,
													"アスキー・メディアワークス",
													label,
													date
													));
					}
				}
			}
			reader.close();
		}catch(Exception e){
			sb.append(this.getClass().getName() + "・");
		}
	}
}