
public class Book {
	private String title;
	private String publisher;
	private String author;
	private String date;
	private String label;
	private String price;
/*テストコード
	public static void main(String[] args){
		Book book = new Book("aaa","bbb","fff","ccc","ddd", "180");
		System.out.println(book);
	}
*/
	public Book(String title, String publisher, String label, String author, String date, String price){
		this.title = title;
		this.publisher = publisher;
		this.author = author;
		this.date = date;
		this.price = price;
		this.label = label;
	}
	public Book(String title, String publisher, String label, String date){
		this.title = title;
		this.publisher = publisher;
		this.label = label;
		this.date = date;

		this.author = "-";
		this.price="-";
	}
	public Book(String title, String publisher, String author, String date, String price){
		this.title = title;
		this.publisher = publisher;
		this.author = author;
		this.date = date;
		this.price = price;

		this.label = "-";
	}

	public String getTitle(){
		return this.title;
	}
	public String getPublisher(){
		return this.publisher;
	}
	public String getAuthor(){
		return this.author;
	}
	public String getDate(){
		return this.date;
	}
	public String getLabel(){
		return this.label;
	}
	public String getPrice(){
		return this.price;
	}

	public String toString(){
		String ctlf = System.getProperty("line.separator");
		return new String(this.title + ctlf
						+ this.author + ctlf
						+ this.publisher + ctlf
						+ this.label + ctlf
						+ this.price + ctlf
						+ this.date);
	}
}
