import java.io.*;
import java.net.*;
import java.util.*;

public class COMGInfogetter implements Runnable{
	private URL url;
	private SortedMap<String, Book> map;
	private StringBuffer sb;
	public COMGInfogetter(URL url, SortedMap<String, Book> map, StringBuffer sb){
		this.url = url;
		this.map = map;
		this.sb = sb;
	}

	public void run(){
		try{
			URLConnection connection =url.openConnection();
			connection.connect();
			BufferedReader reader =
				new BufferedReader(
						new InputStreamReader(
								connection.getInputStream(),
								"utf-8"));
			String line;
			String author = null;
			String title = null;
			String price = null;
			String date = null;
			int flag = 0;
			int offset = 0;
			int offset2 = 0;
			while((line = reader.readLine()) != null){
					//クラスごとに独自の実装
				if((flag == 0)
						&& (line.indexOf("\"title\">") != -1)){
					offset =line.indexOf(">");
					offset2 = line.lastIndexOf("</p>");
					title = line.substring(offset+1, offset2);
					flag++;
				}
				else if((flag == 1)
						&& (line.indexOf("\"auth\">") != -1)){
					offset = line.indexOf(">");
					offset2 = line.lastIndexOf("</p>");
					author = line.substring(offset+1, offset2);
					flag++;
				}
				else if((flag == 2) && (line.indexOf("\"prices\">") != -1)){
					flag++;
				}
				else if(flag == 3){
					offset2 = line.indexOf("円");
					price = line.substring(0, offset2).trim();
					flag++;
				}
				else if(flag == 4){
					offset = line.indexOf("年");
					offset2 = line.indexOf("日");
					date = line.substring(offset+1, offset2).replaceFirst("月", "/");

					map.put(title, new Book(title, "メディアファクトリー", "MFコミックス", author, date, price));
					flag = 0;
				}
			}
			reader.close();
		}catch(Exception e){
			sb.append(this.getClass().getName() + "・");
		}
	}
}