import java.io.*;
import java.util.SortedMap;

import javax.swing.JOptionPane;
public class DataGetterFromXML {
	private File file;
	private SortedMap<String, Book> map;
	public DataGetterFromXML(File file, SortedMap<String, Book> map){
		this.file = file;
		this.map = map;
	}
	public void GetData(){
		try {
			BufferedReader reader =
				new BufferedReader(
					new InputStreamReader(
							new FileInputStream(file), "utf-8"));
			String line;
			String title = null;
			String author = null;
			String publisher = null;
			String label = null;
			String date = null;
			String price = null;
			int flag = 0;
			int offset = 0;
			int offset2 = 0;
			while((line = reader.readLine()) != null){
				if((flag == 0)
						&& (line.indexOf("<title>") != -1)){
					offset = line.indexOf(">");
					offset2 = line.lastIndexOf("<");
					title = line.substring(offset+1, offset2);
					title = title.replaceFirst("<!\\[CDATA\\[", "");
					title = title.substring(0, title.length()-3);
					flag++;
				}
				else if((flag == 1)
						&& (line.indexOf("<author>") != -1)){
					offset = line.indexOf(">");
					offset2 = line.lastIndexOf("<");
					author = line.substring(offset+1, offset2);
					author = author.replaceFirst("<!\\[CDATA\\[", "");
					author = author.substring(0, author.length()-3);
					flag++;
				}
				else if((flag == 2)
						&& (line.indexOf("<publisher>") != -1)){
					offset = line.indexOf(">");
					offset2 = line.lastIndexOf("<");
					publisher = line.substring(offset+1, offset2);
					publisher = publisher.replaceFirst("<!\\[CDATA\\[", "");
					publisher = publisher.substring(0, publisher.length()-3);
					flag++;
				}
				else if((flag == 3)
						&& (line.indexOf("label") != -1)){
					offset = line.indexOf(">");
					offset2 = line.lastIndexOf("<");
					label = line.substring(offset+1, offset2);
					label = label.replaceFirst("<!\\[CDATA\\[", "");
					label = label.substring(0, label.length()-3);
					flag++;
				}
				else if((flag == 4)
						&& (line.indexOf("<date>") != -1)){
					offset = line.indexOf(">");
					offset2 = line.lastIndexOf("<");
					date = line.substring(offset+1, offset2);
					date = date.replaceFirst("<!\\[CDATA\\[", "");
					date = date.substring(0, date.length()-3);
					flag++;
				}
				else if((flag == 5)
						&& (line.indexOf("<price>") != -1)){
					offset = line.indexOf(">");
					offset2 = line.lastIndexOf("<");
					price = line.substring(offset+1, offset2);
					price = price.replaceFirst("<!\\[CDATA\\[", "");
					price = price.substring(0, price.length()-3);

					this.map.put(title, new Book(title, publisher, label, author, date, price));
					flag = 0;
				}
			}
			reader.close();
		} catch (UnsupportedEncodingException e) {
			JOptionPane.showMessageDialog(null, e, "UnsupportedEncodingException", JOptionPane.ERROR_MESSAGE);
		} catch (FileNotFoundException e) {
			JOptionPane.showMessageDialog(null, e, "FileNotFoundException", JOptionPane.ERROR_MESSAGE);
		} catch(IOException e){
			JOptionPane.showMessageDialog(null, e, "IOException", JOptionPane.ERROR_MESSAGE);
		}
	}
}
