import java.io.*;
import java.net.*;
import java.util.*;

public class EBInfogetter implements Runnable{
	private URL url;
	private SortedMap<String, Book> map;
	private StringBuffer sb;
	public EBInfogetter(URL url, SortedMap<String, Book> map, StringBuffer sb){
		this.url = url;
		this.map = map;
		this.sb = sb;
	}

	public void run(){
		try{
			URLConnection connection =url.openConnection();
			connection.connect();
			BufferedReader reader =
				new BufferedReader(
						new InputStreamReader(
								connection.getInputStream(),
								"shift_jis"));
			String line;
			String date = null;
			String title = null;
			String label = null;
			String author = null;
			String price = null;
			int offset = 0;
			int offset2 = 0;
			int flag = 0;
			boolean isb = false;
			while((line = reader.readLine()) != null){
					//クラスごとに独自の実装
				if((flag > 0) && (line.indexOf("</tbody>") != -1)){
					if(isb == true){
						break;
					}
					isb =true;
					flag = 0;
				}
				if((flag == 0)
						&& ((line.indexOf("<table summary=\"コミックス発売予定一覧\">") != -1)
								|| (line.indexOf("文庫の発売予定一覧") != -1))){
					flag++;
				}
				else if((flag == 1) && (line.indexOf("<th>") != -1)){
					offset = line.indexOf(">");
					offset2 = line.lastIndexOf("<");
					String[] temp = line.substring(offset+1, offset2).split("-");
					if(temp.length != 3){
						continue;
					}
					date="".concat(temp[1]).concat("/").concat(temp[2]);
					flag++;
				}
				else if((flag == 2) && (line.indexOf("<a href") != -1)){
					offset = line.indexOf(">");
					offset2 = line.lastIndexOf("<");
					title = line.substring(offset+1, offset2);
					flag++;
				}
				else if((flag == 3) && (line.indexOf("label") != -1)){
					offset = line.indexOf(">");
					offset2 = line.lastIndexOf("<");
					label = line.substring(offset+1, offset2);
					flag++;
					if(label.equals("-")){
						flag = 1;
					}
				}
				else if((flag == 4) && (line.indexOf("writer") != -1)){
					offset = line.indexOf(">");
					offset2 = line.lastIndexOf("<");
					author = line.substring(offset+1, offset2);
					author = author.replaceAll("（", "");
					author = author.replaceAll("）", ":");
					author = author.replaceAll("／", "・");
					flag++;
				}
				else if((flag == 5) && (line.indexOf("price") != -1)){
					flag++;
				}
				else if(flag == 6){
					flag++;
				}
				else if(flag == 7){
					price = line.trim();
					String[] temp = price.split("円");
					price = temp[0];

					map.put(title, new Book(title, "エンターブレイン", label, author, date, price));
					flag = 1;
				}
			}
			reader.close();
		}catch(Exception e){
			sb.append(this.getClass().getName() + "・");
		}
	}
}