import java.io.*;
import java.net.*;
import java.util.*;

public class FujimiInfogetter implements Runnable{
	private URL url;
	private SortedMap<String, Book> map;
	private StringBuffer sb;
	public FujimiInfogetter(URL url, SortedMap<String, Book> map, StringBuffer sb){
		this.url = url;
		this.map = map;
		this.sb = sb;
	}

	public void run(){
		try{
			URLConnection connection =url.openConnection();
			connection.connect();
			BufferedReader reader =
				new BufferedReader(
						new InputStreamReader(
								connection.getInputStream(),
								"utf-8"));
			String line;
			String author = "";
			String price = null;
			String title = null;
			String date = null;
			String label = "ドラゴンコミックスエイジ";
			int flag = 0;
			int offset = 0;
			int offset2 =0;
			while((line = reader.readLine()) != null){
					//クラスごとに独自の実装
				if(line.indexOf("<div id=\"footer\">") != -1){
					break;
				}
				if((flag >= 0)
						&& ((offset = line.indexOf("●ドラゴンコミックスエイジ")) != -1)){
					flag++;
				}
				else if((flag == 1)
						&& ((offset = line.indexOf("<font class=\"j12\"")) != -1)){
					offset = line.indexOf("<b>", offset);
					offset2 = line.lastIndexOf("</b>");
					title = line.substring(offset+3, offset2);
					title = title.trim();
					flag++;
				}
				else if((flag == 2)
						&& (line.indexOf("<font class=\"j12\"") != -1)){
					flag++;
				}
				else if((flag == 3) && (line.indexOf("</font>") != -1)){
					flag++;
				}
				else if(flag == 3){
					String temp = line.trim();
					temp = temp.replaceAll("<br>", "");
					temp = temp.replaceAll("著:", "著者:");
					temp = temp.replaceAll("作:", "原作:");
					temp = temp.replaceAll("案:", "原案:");
					temp = temp.replaceAll("キャラ原:", "キャラクター原案:");
					temp = temp.replaceAll("画:", "作画:");
					temp = temp.replaceAll("キャラデザ:", "キャラクターデザイン:");
					temp = temp.replaceAll("監:", "監修:");
					temp = temp.replaceAll("脚:", "脚本:");
					temp = temp.replaceAll("シ:", "シナリオ:");
					if(author.equals("")){
						author = author.concat(temp);
					}
					else{
						author = author.concat("・" + temp);
					}
				}
				else if((flag == 4)
						&& (line.indexOf("発売日") != -1)){
					offset = line.indexOf("年");
					offset2 = line.indexOf("月");
					date = line.substring(offset+1, offset2);
					date = date.trim();

					offset = line.lastIndexOf("日");
					String temp = line.substring(offset2+1, offset);
					temp = temp.trim();

					date = date + "/" + temp;
					flag++;
				}
				else if((flag == 5)
						&& (line.indexOf("定価") != -1)){
					offset = line.indexOf("：");
					offset2 = line.lastIndexOf("円");
					price = line.substring(offset+1, offset2);

					map.put(title, new Book(title, "富士見書房", label, author, date, price));
					author = "";
					flag = 1;
				}

			}
			reader.close();
		}catch(Exception e){
			sb.append(this.getClass().getName() + "・");
		}
	}
}