import java.io.*;
import java.net.*;
import java.util.*;

public class SyueiSInfogetter implements Runnable{
	private URL url;
	private SortedMap<String, Book> map;
	private StringBuffer sb;
	public SyueiSInfogetter(URL url, SortedMap<String, Book> map, StringBuffer sb){
		this.url = url;
		this.map = map;
		this.sb = sb;
	}

	public void run(){
		try{
			URLConnection connection =url.openConnection();
			connection.connect();
			BufferedReader reader =
				new BufferedReader(
						new InputStreamReader(
								connection.getInputStream(),
								"shift_jis"));
			String line;
			String label = "スーパーダッシュ文庫";
			String author = null;
			String price = null;
			String date = null;
			String title = null;
			int offset = 0;
			int offset2 = 0;
			while((line = reader.readLine()) != null){
					//クラスごとに独自の実装
				if(line.indexOf("<TD class=\"midashi04\">") != -1){
					offset = line.indexOf("<a href=");
					offset = line.indexOf(">", offset);
					offset2 = line.indexOf("</a>", offset);

					title = line.substring(offset+1, offset2);

					offset = line.indexOf("<TD class=\"midashi04\">", offset2);
					offset = line.indexOf(">", offset);
					offset2 = line.indexOf("</TD>", offset);
					author = line.substring(offset+1, offset2);
					author = author.replaceAll("　", "");
					if(author.indexOf("・著") != -1){
						author = author.replaceFirst("・著", "");
						author = "著者：" + author;
					}

					if(author.indexOf("・画") != -1){
						author = author.replaceFirst("・画", "");
						author = author.replaceFirst("/", "/イラスト：");
					}
					if(author.indexOf("/") != -1){
						author = author.replaceAll("/", "・");
					}

					offset = line.indexOf("<TD class=\"midashi04\">", offset2);
					offset = line.indexOf("年", offset);
					offset2 = line.indexOf("</TD>", offset);

					date = line.substring(offset+1, offset2);
					date = date.replaceFirst("月", "/");
					date = date.replaceFirst("日", "");

					offset = line.indexOf("<TD class=\"midashi04\">", offset2);
					offset = line.indexOf(">", offset);
					offset2 = line.indexOf("円", offset);

					price = line.substring(offset+1, offset2);

					map.put(title, new Book(title, "集英社", label, author, date, price));
				}
			}
			reader.close();
		}catch(Exception e){
			sb.append(this.getClass().getName() + "・");
		}
	}
}