import java.io.*;
import java.net.*;
import java.util.*;

public class COMAInfogetter implements Runnable{
	private URL url;
	private SortedMap<String, Book> map;
	private StringBuffer sb;
	public COMAInfogetter(URL url, SortedMap<String, Book> map, StringBuffer sb){
		this.url = url;
		this.map = map;
		this.sb = sb;
	}

	public void run(){
		try{
			URLConnection connection =url.openConnection();
			connection.connect();
			BufferedReader reader =
				new BufferedReader(
						new InputStreamReader(
								connection.getInputStream(),
								"euc_jp"));
			String line;
			String author = null;
			String title = null;
			String price = null;
			String date = null;
			int flag = 0;
			int offset = 0;
			int offset2 = 0;
			while((line = reader.readLine()) != null){
					//クラスごとに独自の実装
				if(line.indexOf("<!-- comics list  Main end -->") != -1){
					break;
				}
				if((flag == 0) && ((offset = line.indexOf("\"comicsListTitle\">")) != -1)){
					offset = line.indexOf(">", offset);
					offset2 = line.indexOf("<span", offset);
					title = line.substring(offset+1, offset2);
					title = title.replaceFirst("MFコミックス　", "");
					title = title.replaceAll("&lt;", "<");
					title = title.replaceAll("&gt;", ">");

					offset = line.indexOf(">", offset2);
					offset2 = line.indexOf("</span>", offset);
					author = line.substring(offset+1, offset2).replaceAll("／", "・").replaceAll("：", ":");
					flag++;
				}
				else if((flag == 1)
						&& (line.indexOf("\"comicsListReleaseDay\">") != -1)){
					offset = line.indexOf("/");
					offset2 = line.indexOf("　", offset);
					date = line.substring(offset+1, offset2);

					offset = line.indexOf("価", offset2);
					offset2 = line.indexOf("円", offset);
					price = line.substring(offset+1, offset2);

					map.put(title, new Book(title, "メディアファクトリー", "MFコミックス", author, date, price));
					flag = 0;
				}
			}
			reader.close();
		}catch(Exception e){
			sb.append(this.getClass().getName() + "・");
		}
	}
}