import java.io.*;
import java.net.*;
import java.util.*;

public class HOUBCInfogetter implements Runnable{
	private URL url;
	private SortedMap<String, Book> map;
	private StringBuffer sb;
	public HOUBCInfogetter(URL url, SortedMap<String, Book> map, StringBuffer sb){
		this.url = url;
		this.map = map;
		this.sb = sb;
	}

	public void run(){
		try{
			URLConnection connection =url.openConnection();
			connection.connect();
			BufferedReader reader =
				new BufferedReader(
						new InputStreamReader(
								connection.getInputStream(),
								"shift_jis"));
			String line;
			String author = null;
			String title = null;
			String label = "まんがタイムＫＲコミックス";
			String price = null;
			String date = null;
			int flag = 0;
			int offset = 0;
			int offset2 = 0;
			while((line = reader.readLine()) != null){
					//クラスごとに独自の実装
				if(line.indexOf("<!-- Contents navigation -->") != -1){
					break;
				}
				if((flag == 0)
						&& ((offset = line.indexOf("<strong>")) != -1)){
					offset = line.indexOf(">", offset);
					offset2 = line.lastIndexOf("</strong>");
					title = line.substring(offset+1, offset2).trim();
					if(title.endsWith("　")){
						title = title.substring(0, title.length()-1);
					}
					flag++;
				}
				else if(flag == 1){
					offset = line.indexOf(">");
					offset2 = line.lastIndexOf("</p>");
					author = line.substring(offset+1, offset2).replaceAll(" ", "");
					flag++;
				}
				else if(flag == 2){
					offset = line.indexOf("年");
					offset2 = line.indexOf("日", offset);
					date = line.substring(offset+1, offset2).replaceFirst("月", "/");

					offset = line.indexOf("定価:");
					offset2 = line.lastIndexOf("円");
					price = line.substring(offset+3, offset2);

					map.put(title, new Book(title, "芳文社", label, author, date, price));
					flag = 0;
				}
			}
			reader.close();
		}catch(Exception e){
			sb.append(this.getClass().getName() + "・");
		}
	}
}