import java.io.*;
import java.net.*;
import java.util.*;
import java.text.SimpleDateFormat;

public class HUTInfogetter implements Runnable{
	private URL url;
	private SortedMap<String, Book> map;
	private StringBuffer sb;
	public HUTInfogetter(URL url, SortedMap<String, Book> map, StringBuffer sb){
		this.url = url;
		this.map = map;
		this.sb = sb;
	}

	public void run(){
		try{
			URLConnection connection =url.openConnection();
			connection.connect();
			BufferedReader reader =
				new BufferedReader(
						new InputStreamReader(
								connection.getInputStream(),
								"utf-8"));
			Date d = new Date();
			SimpleDateFormat sdf = new SimpleDateFormat("MM");
			String month = sdf.format(d);

			String line;
			String author = null;
			String title = null;
			String date = null;
			int offset = 0;
			int offset2 = 0;
			while((line = reader.readLine()) != null){
					//クラスごとに独自の実装
				if((line.indexOf("class=weekday") != -1)
						|| (line.indexOf("class=saturday") != -1)
						|| (line.indexOf("class=sunday") != -1)){
					offset = line.indexOf(">");
					offset2 = line.indexOf("日");
					date = month + "/" +line.substring(offset+1, offset2).trim();
				}
				if((offset = line.indexOf("alt =\"コミック\">")) != -1){
					offset = line.indexOf(";", offset);
					offset2 = line.indexOf("<", offset);
					title = line.substring(offset+1, offset2);
					title = title.replaceAll("&nbsp;", "");

					offset = line.indexOf("class=\"auther\">");
					offset = line.indexOf(">", offset);
					offset2 = line.indexOf("<", offset);
					author = line.substring(offset+1, offset2);
					author = author.replaceAll("&nbsp;", "").trim();
					author = author.replaceAll("\\(著\\)", "");
					author = "著者：" + author;
					author = author.replaceAll(" ", "・著者：");

					map.put(title, new Book(title, "双葉社", "-", author, date, "-"));
				}
			}
			reader.close();
		}catch(Exception e){
			sb.append(this.getClass().getName() + "・");
		}
	}
}