import java.io.*;
import java.net.*;
import java.util.*;

public class ItijinInfogetter implements Runnable{
	private URL url;
	private SortedMap<String, Book> map;
	private StringBuffer sb;
	public ItijinInfogetter(URL url, SortedMap<String, Book> map, StringBuffer sb){
		this.url = url;
		this.map = map;
		this.sb = sb;
	}

	public void run(){
		try{
			URLConnection connection =url.openConnection();
			connection.connect();
			BufferedReader reader =
				new BufferedReader(
						new InputStreamReader(
								connection.getInputStream(),
								"euc-jp"));
			String line;
			String author = "";
			String title = null;
			String label = null;
			String price = null;
			String date = null;
			int flag = 0;
			int offset = 0;
			int offset2 = 0;
			while((line = reader.readLine()) != null){
					//クラスごとに独自の実装
				if(line.indexOf("<h2>") != -1){
					offset = line.indexOf(">");
					offset2 = line.lastIndexOf("</h2>");
					label = line.substring(offset+1, offset2);
					if(label.equals("ノベル")){
						label = "一迅社文庫";
					}
					else if(label.equals("書籍")){
						label = "-";
					}
				}
				if((flag == 0)
						&& ((offset = line.indexOf("<h3>")) != -1)){
					offset = line.indexOf(">", offset);
					offset = line.indexOf(">", offset+1);
					offset2 = line.lastIndexOf("</a>");
					title = line.substring(offset+1, offset2);
					title = title.replaceAll("&amp;", "&");
					flag++;
				}
				else if(((flag == 1) || (flag == 2))
						&& ((offset = line.indexOf("<nobr>")) != -1)){
					offset = line.indexOf(">", offset);
					offset2 = line.indexOf("<", offset);
					String temp = line.substring(offset+1, offset2);
					if(temp.equals("作 : "))
						temp = "作者:";
					else if(temp.equals("絵 : "))
						temp = "イラスト:";
					else if(temp.equals("原作 : "))
						temp = "原作:";
					if(flag == 2)
						temp = "・".concat(temp);
					author = author.concat(temp);

					offset2 = line.lastIndexOf("<");
					offset = line.lastIndexOf(">", offset2);
					temp = line.substring(offset+1, offset2);
					if(temp.endsWith("・編")){
						offset2 = line.lastIndexOf("・");
						temp = line.substring(offset+1, offset2);
					}
					author = author.concat(temp);
					flag=2;
				}
				else if((flag == 2 || flag == 3)
						&& (line.indexOf("<br>") != -1)){
					flag = 4;
				}
				else if(flag == 4){
					flag++;
				}
				else if(flag == 5){
					offset = line.indexOf("判 ");
					offset2 = line.lastIndexOf("円");
					price = line.substring(offset+2, offset2);
					price = price.replaceAll(",", "");
					flag++;
				}
				else if(flag == 6){
					offset = line.indexOf("年");
					offset2 = line.lastIndexOf("日");
					date = line.substring(offset+1, offset2);
					date = date.replaceFirst("月", "/");

					map.put(title, new Book(title, "一迅社", label, author, date, price));
					author = "";
					flag = 0;
				}
			}
			reader.close();
		}
		catch(Exception e){
			sb.append(this.getClass().getName() + "・");
		}
	}
}