import java.io.*;
import java.net.*;
import java.util.*;

public class MAGInfogetter implements Runnable{
	private URL url;
	private SortedMap<String, Book> map;
	private StringBuffer sb;
	public MAGInfogetter(URL url, SortedMap<String, Book> map, StringBuffer sb){
		this.url = url;
		this.map = map;
		this.sb =sb;
	}

	public void run(){
		try{
			URLConnection connection =url.openConnection();
			connection.connect();
			BufferedReader reader =
				new BufferedReader(
						new InputStreamReader(
								connection.getInputStream(),
								"utf-8"));
			String line;
			String title = null;
			String author = null;
			String date = null;
			String price = null;
			String label = null;
			int flag = 0;
			int offset = 0;
			int offset2 = 0;
			while((line = reader.readLine()) != null){
					//クラスごとに独自の実装
				if(line.indexOf("<div id=\"footer\">") != -1){
					break;
				}
				if((flag > 0) && (line.indexOf("<!--/.label-->") != -1)){
					flag = 0;
				}
				else if((flag == 0)
						&& ((line.indexOf("<a name=\"blade\">") != -1)
								|| (line.indexOf("<a name=\"avarus\">") != -1)
								|| (line.indexOf("<a name=\"eden\">") != -1))){
					flag++;
				}
				else if(flag == 1){
					label = line.trim();
					flag++;
				}
				else if((flag == 2)
						&& (line.indexOf("<p class=\"title\">") != -1)){
					offset = line.indexOf(">");
					offset2 = line.lastIndexOf("<");
					title = line.substring(offset+1, offset2);
					flag++;
				}
				else if((flag == 3)
						&& (line.indexOf("<p class=\"author\">") != -1)){
					offset = line.indexOf(">");
					offset2 = line.lastIndexOf("<");
					author = line.substring(offset+1, offset2);
					String[] temp = author.split("／");
					author = temp[0];
				}
				else if((flag == 3)
						&& (line.indexOf("<td class=\"data\">") != -1)){
					flag++;
				}
				else if(flag == 4){
					offset = line.indexOf("年");
					offset2 = line.indexOf("月");
					String temp = line.substring(offset+1, offset2);
					offset = line.indexOf("日");
					String temp2 = line.substring(offset2+1, offset);

					date = temp + "/" + temp2;

					offset = line.indexOf("本体");
					offset2 = line.lastIndexOf("円");

					price = line.substring(offset+2, offset2);

					map.put(title, new Book(title, "マッグガーデン", label, author, date, price));
					flag = 2;
				}
			}
		}catch(Exception e){
			sb.append(this.getClass().getName() + "・");
		}
	}
}