import java.io.*;
import java.net.*;
import java.util.*;

public class MFBInfogetter implements Runnable{
	private URL url;
	private SortedMap<String, Book> map;
	private StringBuffer sb;
	public MFBInfogetter(URL url, SortedMap<String, Book> map, StringBuffer sb){
		this.url = url;
		this.map = map;
		this.sb = sb;
	}

	public void run(){
		try{
			URLConnection connection =url.openConnection();
			connection.connect();
			BufferedReader reader =
				new BufferedReader(
						new InputStreamReader(
								connection.getInputStream(),
								"utf-8"));
			String line;
			String author = null;
			String title = null;
			String price = null;
			String date = null;
			int flag = 0;
			int offset = 0;
			int offset2 = 0;
			while((line = reader.readLine()) != null){
					//クラスごとに独自の実装
				if(line.indexOf("<!-- 新刊詳細 END -->") != -1){
					break;
				}
				if((flag == 0)
						&& (line.indexOf("<div class=\"detail_title\">") != -1)){
					offset = line.indexOf("<H3>");
					offset = line.indexOf(">", offset);
					offset2 = line.lastIndexOf("</H3>");
					title = line.substring(offset+1, offset2);
					flag++;
				}
				else if((flag == 1)
						&& ((offset = line.indexOf("class=\"a_author\">")) != -1)){
					offset = line.indexOf(">", offset);
					offset2 = line.indexOf("</a>", offset);
					author = "著者:" + line.substring(offset+1, offset2);
					flag++;
				}
				else if((flag == 2)
						&& ((offset = line.indexOf("class=\"a_author\">")) != -1)){
					offset = line.indexOf(">", offset);
					offset2 = line.indexOf("</a>", offset);
					author = author + "・イラスト:" + line.substring(offset+1, offset2);
					flag++;
				}
				else if((flag == 3)
						&& (line.indexOf("<div class=\"detail_authour\">") != -1)){
					flag++;
				}
				else if(flag == 4){
					offset = line.indexOf(")");
					offset2 = line.indexOf("円", offset);
					price = line.substring(offset+1, offset2);
					flag++;
				}
				else if(flag == 5){
					offset = line.indexOf("年");
					offset2 = line.lastIndexOf("日");
					date = line.substring(offset+1, offset2).replaceFirst("月", "/");

					map.put(title, new Book(title, "メディアファクトリー", "MF文庫J", author, date, price));
					flag = 0;
				}
			}
			reader.close();
		}catch(Exception e){
			sb.append(this.getClass().getName() + "・");
		}
	}
}