import java.io.*;
import java.net.*;
import java.util.*;
import java.text.SimpleDateFormat;

public class SEnixInfogetter implements Runnable{
	private URL url;
	private SortedMap<String, Book> map;
	private StringBuffer sb;
	public SEnixInfogetter(URL url, SortedMap<String, Book> map, StringBuffer sb){
		this.sb =sb;
		Date date = new Date();
		SimpleDateFormat sdf1 = new SimpleDateFormat("yyMM");
		String temp = sdf1.format(date);
		this.url = null;
		try{
			this.url = new URL(url.toString().concat(temp+"release.html"));
		}catch(MalformedURLException mfue){
			sb.append(mfue + "・");
		}
		this.map = map;
	}

	public void run(){
		try{
			URLConnection connection =url.openConnection();
			connection.connect();
			BufferedReader reader =
				new BufferedReader(
						new InputStreamReader(
								connection.getInputStream(),
								"shift_jis"));
			String line;
			String date = null;
			String label = null;
			String title = null;
			String author = null;
			String price = null;
			String[] labelArray = {"ガンガンコミックスJOKER",
									"ヤングガンガンコミックス",
									"ガンガンコミックス",
									"ガンガンコミックスDX",
									"ガンガンコミックスONLINE",
									"Gファンタジーコミックス",
									"ガンガンノベルズ"
									};
			int flag = 0;
			int offset = 0;
			int offset2 = 0;
			while((line = reader.readLine()) != null){
					//クラスごとに独自の実装
				if((flag > 0) && (line.indexOf("</table>") != -1)){
					break;
				}
				if((flag == 0) && (line.indexOf("<tr align=\"center\">") != -1)){
					flag++;
				}
				else if((flag == 1) && (line.indexOf("<tr align=\"center\">") != -1)){
					flag++;
				}
				else if(flag == 2){
					flag++;
				}
				else if(flag == 3){
					offset = line.indexOf("<p>");
					offset2 = line.lastIndexOf("</p>");
					date = line.substring(offset+3, offset2);
					String[] temp = date.split("\\.");
					date = temp[1] + "/" + temp[2];
					flag++;
				}
				else if(flag == 4){
					offset = line.indexOf(">");
					offset2 = line.lastIndexOf("<");
					label = line.substring(offset+1, offset2);
					flag = 1;
					for(int i = 0; i < labelArray.length; i++){
						if(label.equals(labelArray[i])){
							flag = 5;
							break;
						}
					}
				}
				else if(flag == 5){
					int tempOffset = line.indexOf("<font");
					offset = line.indexOf(">", tempOffset);
					offset2 = line.lastIndexOf("<");
					title = line.substring(offset+1, offset2);
					String[] temp = title.split("<br />");
					title = "";
					for(int i = 0; i < temp.length; i++){
						title = title.concat(temp[i]);
					}
					flag++;
				}
				else if(flag == 6){
					offset = line.indexOf(">");
					offset2 = line.lastIndexOf("<");
					author = line.substring(offset+1, offset2);
					String[] temp = author.split("<br />");
					author = "";
					for(int i = 0; i < temp.length; i++){
						author = author.concat(temp[i]);
						if((i != temp.length -1) && (!author.endsWith("・"))){
							author = author.concat("・");
						}
					}
					flag++;
				}
				else if(flag == 7){
					flag++;
				}
				else if(flag == 8){
					offset = line.indexOf(">");
					offset2 = line.lastIndexOf("<");
					price = line.substring(offset+1, offset2);
					String[] temp = price.split(",");
					price = "";
					for(int i = 0; i < temp.length; i++){
						price = price.concat(temp[i]);
					}
					price = price.substring(1, price.length());

					map.put(title, new Book(title,
											"スクウェア・エニックス",
											label,
											author,
											date,
											price));
					flag = 1;
				}
			}
			reader.close();
		}catch(Exception e){
			sb.append(this.getClass().getName() + "・");
		}
	}
}