import java.io.*;
import java.net.*;
import java.util.*;

import javax.swing.JOptionPane;

public class SYOGKCsubInfogetter implements Runnable{
	private URL url;
	private SortedMap<String, Book> map;
	private StringBuffer sb;


	public static void main(String[] args){
		URL url = null;
		try{
			url = new URL("http://skygarden.shogakukan.co.jp/skygarden/owa/solc_new?mm=0&type=c&seq=0&page=2");
		}catch(MalformedURLException me){
			JOptionPane.showMessageDialog(null,
					"アドレスエラー",
					"アドレスエラー",
					JOptionPane.ERROR_MESSAGE);
		}
		SortedMap<String, Book> m =
			Collections.synchronizedSortedMap(
					new TreeMap<String, Book>());


		StringBuffer ssb = new StringBuffer();
		Thread t = new Thread(new SYOGKCsubInfogetter(url, m, ssb));
		/*
		 * Exceptionの部分をIOExceptionにする
		 */
		t.start();
		try{
			t.join();
		}catch(InterruptedException ie){
			System.out.println(ie);
		}
		Set<String> tempSet = m.keySet();
		for(String temp : tempSet){
			Book b = m.get(temp);
			System.out.println(b.toString());
		}
	}



	public SYOGKCsubInfogetter(URL url, SortedMap<String, Book> map, StringBuffer sb){
		this.url = url;
		this.map = map;
		this.sb = sb;
	}

	public void run(){
		try{
			URLConnection connection =url.openConnection();
			connection.connect();
			BufferedReader reader =
				new BufferedReader(
						new InputStreamReader(
								connection.getInputStream(),
								"shift_jis"));
			String line;
			String author = null;
			String title = null;
			String price = null;
			String date = null;
			String label = null;
			int flag = 0;
			int offset = 0;
			int offset2 = 0;
			while((line = reader.readLine()) != null){
					//クラスごとに独自の実装
				if(line.indexOf("<!-- 20列目終了 -->") != -1){
					break;
				}
				else if((flag == 0)
						&& (line.indexOf("<td class=\"SearchResultText03 middle\">") != -1)){
					offset = line.indexOf(">");
					offset2 = line.lastIndexOf("</td>");
					label = line.substring(offset+1, offset2);
					flag++;
				}
				else if((flag == 1)
						&& (line.indexOf("<td class=\"SearchResultText04 middle\">") != -1)){
					offset = line.indexOf(">", line.indexOf(">")+1);
					offset2 = line.lastIndexOf("</a>");
					if(offset2 < 0){
						offset = line.indexOf(">");
						offset2 = line.lastIndexOf("</td>");
					}
					title = line.substring(offset+1, offset2);

					flag++;
				}
				else if((flag == 2)
						&& (line.indexOf("<td class=\"SearchResultText04 middle\">") != -1)){
					offset = line.indexOf(">", line.indexOf(">")+1);
					offset2 = line.lastIndexOf("</a>");
					if(offset2 < 0){
						offset = line.indexOf(">");
						offset2 = line.lastIndexOf("</td>");
					}
					author = line.substring(offset+1, offset2);
					author = author.replaceAll("/", "・");
					flag++;
				}
				else if((flag == 3)
						&& (line.indexOf("<td class=\"SearchResultText05 middle\">") != -1)){
					offset = line.indexOf(">");
					offset2 = line.lastIndexOf("</td>");
					price = line.substring(offset+1, offset2);
					price = price.replaceAll(" ", "").replaceFirst("￥", "").replaceAll(",", "");
					flag++;
				}
				else if((flag == 4)
						&& (line.indexOf("<td class=\"SearchResultText05 middle\">") != -1)){
					offset = line.indexOf("/");
					offset2 = line.lastIndexOf("</td>");
					date = line.substring(offset+1, offset2);

					map.put(title, new Book(title, "小学館", label, author, date, price));
					flag = 0;
				}
			}
			reader.close();
		}catch(IOException e){
			System.out.println(e);
			sb.append(this.getClass().getName() + "・");
		}
	}
}