import java.io.*;
import java.net.*;
import java.util.*;

import javax.swing.JOptionPane;


public class SyueiCInfogetter implements Runnable{
	private URL url;
	private SortedMap<String, Book> map;
	private StringBuffer sb;

	public SyueiCInfogetter(URL url, SortedMap<String, Book> map, StringBuffer sb){
		this.url = url;
		this.map = map;
		this.sb = sb;
	}

	public void run(){
		try{
			URLConnection connection =url.openConnection();
			connection.connect();
			BufferedReader reader =
				new BufferedReader(
						new InputStreamReader(
								connection.getInputStream(),
								"utf-8"));
			String line = null;
			while((line = reader.readLine()) != null){
					//クラスごとに独自の実装
				if(line.indexOf("<div class=\"section Clearfix BlogContents catJump\">") != -1){
					break;
				}
			}
			String[] temp = line.split("(<.+?>)+");
			line = null;
			String label = "";
			String date = "";
			String price = "";
			String title = "";
			String author = "";
			String[] labelArray = {"ジャンプコミックス",
									"ジャンプコミックスデラックス",
									"りぼんマスコットコミックス",
									"クイーンズコミックス",
									"ヤングジャンプコミックス",
									"プレイボーイコミックス",
									"オフィスユーコミックス",
									"マーガレットコミックス",
									"集英社文庫コミック版",
									"ホームコミックス",
									"ホーム社eyesコミックス"};

			int cnt = 0;
			for(int i = 1; i < temp.length; i++){

				if((temp[i].equals("該当のコミックスはありません。"))
						|| (temp[i].equals("ページTOPに戻る"))){
					cnt = 0;
					continue;
				}

				if(cnt == 0){
					for(int j = 0; j < labelArray.length; j++){
						if(temp[i].equals(labelArray[j]) &&
								(temp[i].equals(temp[i+1]) == false)){
							label = temp[i];
							cnt++;
						}
					}
				}
				else if(cnt == 1){
					date = temp[i].replaceAll("\\.", "/");
					cnt++;
				}
				else if(cnt == 2){
					try{
							price = temp[i].substring(temp[i].indexOf("：")+1, temp[i].indexOf("円"));
						}catch(Exception e){
							price = "?";
						}
					cnt++;
				}
				else if(cnt == 3){
					title = temp[i].replaceAll("&#8217;", "'");
					title = temp[i].replaceAll("&amp;", "&");

					cnt++;
				}
				else if(cnt == 4){
					if(temp[i].indexOf("/") == -1){
						if(author.equals("")){
							author = temp[i];
						}
						else{
							i--;
						}

						map.put(title, new Book(title,
												"集英社",
												label,
												author,
												date,
												price));
						author = "";
						cnt = 0;
					}
					else{
						String te = temp[i].replaceFirst("/", ":");
						if(author.equals("")){
							author = author.concat(te);
						}
						else{
							author = author.concat("・" + te);
						}
					}
				}
			}
			reader.close();
		}catch(Exception e){
			sb.append(this.getClass().getName() + "・");
		}
	}
}